/// <reference types="zen-observable" />
import { Operation, NextLink, FetchResult } from './types';
import * as Observable from 'zen-observable';
import { ApolloLink } from './link';
export default class RetryLink extends ApolloLink {
    private count;
    private delay;
    private max;
    private interval;
    private subscription;
    private timer;
    constructor(params?: {
        max?: number;
        delay?: number;
        interval?: (delay: number, count: number) => number;
    });
    request(operation: Operation, forward: NextLink): Observable<FetchResult>;
    private defaultInterval;
}
